config/routes.rb
Rails.application.routes.draw do
  resources :students do 
    get "/check" => "students#check"
  end

  resources :teachers do 
    get "/change_password", to: "teachers#change_password"
  end

  resources :cells do 
    get "/students_personal_details" => 'cells#students_personal_details'
    get "/summary" => 'cells#summary'
  end
  
  resources :instructions
  resources :attendances
  
  resources :users
  resources :sessions, only: [:new, :create, :destroy]
  
  root 'cells#index'
  get '/' => 'cells#index'
  get '/login', to: 'sessions#new', as: 'login'
  get '/logout', to: 'sessions#destroy', as: 'logout'
  get '/search', to: 'application#searchByName'
  get "/admin", to: "application#admin"
  get "/cells_all", to: "cells#all"

end

app/models/cell.rb
class Cell < ActiveRecord::Base
    has_many :attendances
    has_many :students, through: :attendances
    
    has_many :instructions
    has_many :teachers, through: :instructions
    
    validates_presence_of :year, :grade
    validates :group, format: { with: /\A\d?[A-Z]?\z/, message: "invalid input" }, allow_blank: true
    
    def long_year
        if self.year != nil
            self.year.to_s + " - " + (self.year+1).to_s
        end
    end
    
    def name 
        if self.group?
           self.grade + " " + self.group 
        else
           self.grade 
        end
    end
    
    def sort_param 
       case
       when self.grade == "Trưởng Ban"
            "0"
       when self.grade == "Kỹ Thuật"
            "1"
       when self.grade == "Khai Tâm"
            "2" + self.group
       when self.grade == "Rước Lễ"
            "3" + self.group
       when self.grade == "Thêm Sức"
            "4" + self.group
       when self.grade == "Bao Đồng"
            "5" + self.group
       else
            "6"
       end
    end
end

app/controllers/cells_controller.rb
class CellsController < ApplicationController
  before_action :set_cell, only: [:show, :edit, :update, :destroy]
  before_action :auth 
  before_action :isAdmin, only: [:new, :create, :edit, :update, :destroy]

  # GET /cells
  # GET /cells.json
  def index
    @cells = Cell.where(year: @current_year).where(grade: ["Khai Tâm", "Rước Lễ", "Thêm Sức", "Bao Đồng"]).sort_by {|c| c.sort_param}
    # TODO: add isClass field to cell
    
    respond_to do |format|
      format.html
      format.pdf do 
        pdf = CellsPdf.new(@cells)
        send_data pdf.render , filename: "Thống Kê Các Lớp Năm Học #{@cells.first.long_year}.pdf", type: "application/pdf", disposition: "inline"
      end
    end
  end

  def all
    @cells = Cell.all
  end

  # GET /cells/1
  # GET /cells/1.json
  def show
    @instructions = @cell.instructions
    @attendances = @cell.attendances
    
    respond_to do |format|
      format.html
      format.xlsx do
        response.headers[
          'Content-Disposition'
        ] = "attachment; filename=#{@cell.name}.xlsx"
      end
      format.pdf do
        pdf = StudentsPdf.new(@attendances, @cell)
       send_data pdf.render, filename: "Danh Sách Lớp #{@cell.name} Năm Học #{@cell.long_year}.pdf", type: "application/pdf", disposition: "inline"
      end
    end
  end

  # GET /cells/new
  def new
    @cell = Cell.new
  end

  # GET /cells/1/edit
  def edit
  end

  # POST /cells
  # POST /cells.json
  def create
    @cell = Cell.new(cell_params)

    respond_to do |format|
      if @cell.save
        flash[:success] = 'Cell was successfully created.'
        format.html { redirect_to @cell }
        format.json { render :show, status: :created, location: @cell }
      else
        format.html { render :new }
        format.json { render json: @cell.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cells/1
  # PATCH/PUT /cells/1.json
  def update
    respond_to do |format|
      if @cell.update(cell_params)
        flash[:success] = 'Cell was successfully updated.'
        format.html { redirect_to @cell }
        format.json { render :show, status: :ok, location: @cell }
      else
        format.html { render :edit }
        format.json { render json: @cell.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cells/1
  # DELETE /cells/1.json
  def destroy
    @cell.instructions.each do |ins|
      ins.destroy
    end

    @cell.attendances.each do |att|
      att.destroy
    end

    @cell.destroy
    respond_to do |format|
      flash[:success] = 'Cell was successfully destroyed.'
      format.html { redirect_to cells_url }
      format.json { head :no_content }
    end
  end
  
  def students_personal_details
    @cell = Cell.find(params[:cell_id])
    @students = @cell.students.sort_by{|student| student.sort_param}
    
    respond_to do |format|
      format.html
      
      format.pdf do
        pdf = StudentsPersonalDetailsPdf.new(@students)
        send_data pdf.render, filename: "Sơ Yếu Lý Lịch Lớp #{@cell.name} Năm Học #{@cell.long_year}.pdf", type: "application/pdf", disposition: "inline"
      end
    end

  end

  def summary
    @cell = Cell.find(params[:cell_id])
    @instructions = @cell.instructions.order(:position)
  end
  
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cell
      @cell = Cell.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cell_params
      params.require(:cell).permit(:year, :grade, :group, :location)
    end

end

app/helpers/cells_helper.rb
module CellsHelper
end

app/views/cells/_form.html.erb
<%= form_for(@cell) do |f| %>
  <% if @cell.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@cell.errors.count, "error") %> prohibited this group from being saved:</h2>

      <ul>
      <% @cell.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  
  <p style="margin:10px"></p>
  
  <fieldset>

    <div class="block">
      <div class="label">Khối:</div>
      <%= f.text_field :grade %>
    </div>

    <div class="block">
      <div class="label">Lớp:</div>
      <%= f.text_field :group %>
    </div>
    
    <div class="block">
      <div class="label">Năm Học:</div>
      <strong><%= @cell.long_year %></strong>
    </div>

    <div class="block">
      <div class="label">Vị Trí Lớp:</div>
      <%= f.text_field :location %>
    </div>

  </fieldset>
  
  <div class="actions" style="padding-top:10px">
    <%= f.submit "Cập Nhật", :class => "button" %>
  </div>
<% end %>

app/views/cells/_form_for_new.html.erb
<%= form_for(@cell) do |f| %>
  <% if @cell.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@cell.errors.count, "error") %> prohibited this cell from being saved:</h2>

      <ul>
      <% @cell.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :year %><br>
    <%= f.number_field :year %>
  </div>
  <div class="field">
    <%= f.label :grade %><br> 
    <%= f.text_field :grade %>
  </div>
  <div class="field">
    <%= f.label :group %><br>
    <%= f.text_field :group %>
  </div>
  <div class="field">
    <%= f.label :location %><br>
    <%= f.text_field :location %>
  </div>
  <div class="actions"> 
    <%= f.submit "Cập Nhật", :class => "button" %>
  </div>
<% end %>

app/views/cells/edit.html.erb
<h1>Cập Nhật Thông Tin Lớp</h1>

<%= render 'form' %>
<%= link_to 'Quay Lại', :back, :class => "button" %>
<%= link_to 'Xóa', @cell, method: :delete, data: { confirm: 'Xóa Hành Trình Thiêng Liêng của thiếu nhi và giáo lý viên trong lớp này? Nên cập nhật thông tin thay vì xóa. Are you sure?' }, :class => "button-caution" %>

app/views/cells/index.html.erb
<h1>Thống Kê Số Lượng Thiếu Nhi Năm Học <%= @current_year_long %></h1>
<h4>Số Lượng : <%= @cells.count %></h4>

<table>
  <thead>
    <tr>
      <th stye="width: 50px">STT</th>
      <th style='width: 100px'>Tên Lớp</th>
      <th style='width:  94px'>Tổng Số</th>
      <th style='width:  94px'>Nghỉ Luôn</th>
      <th style='width:  94px'>Chuyển Xứ</th>
      <th style='width:  94px'>Đang Học</th>
      <th style='width:  94px'>Lên Lớp</th>
      <th style='width:  94px'>Học Lại</th>
    </tr>
  </thead>

  <tbody>
    <% @cells.each do |cell| %>
    <% default_location = "Vô Gia Cư"; default_location = cell.location if cell.location? %>
      <tr class="table-row">
        <td style='width: 50px'><%= @cells.index(cell) + 1 %></td>
        <td style='width: 100px'><%= link_to cell.name, cell %></td>
        <td style='width:  94px'><%= cell.attendances.count %></td>
        <td style='width:  94px'><%= cell.attendances.where(result: 'Nghỉ Luôn').count %></td>
        <td style='width:  94px'><%= cell.attendances.where(result: 'Chuyển Xứ').count %></td>
        <td style='width:  94px'><%= cell.attendances.where(result: 'Đang Học').count %></td>
        <td style='width:  94px'><%= cell.attendances.where(result: 'Lên Lớp').count %></td>
        <td style='width:  94px'><%= cell.attendances.where(result: 'Học Lại').count %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<div class="divider"></div>
<%= link_to "In Bảng Thống Kê", cells_path(format: "pdf"), :class => "button" %>

app/views/cells/new.html.erb
<h1>New Cell</h1>

<%= render 'form_for_new' %>

<%= link_to 'Quay Lại', :back, :class => "button" %>

app/views/cells/show.html.erb
<h1>Thông Tin Lớp</h1>

<p style="margin:10px"></p>
  
<fieldset>    
  <div class="block">
    <div class="label">Năm Học:</div>
    <strong><%= @cell.long_year %></strong>
  </div>

  <div class="block">
    <div class="label">Tên Lớp:</div>
    <strong><%= @cell.name %></strong>
  </div>
   
  <div class="block">
    <div class="label">Vị Trí Lớp:</div>
    <strong><%= @cell.location %></strong>  
  </div>
</fieldset>  
<%= link_to 'Chỉnh Sửa', edit_cell_path(@cell), :class =>"button" %>

<div class="divider"></div>
<h1>Giáo Lý Viên</h1>

<%= render 'teachers/info_table' %>
<div class="divider"></div>

<%= link_to "Số điện thoại GLV", cell_path(@cell)+"/summary", :class =>"button" %>
<div class="divider"></div>

<h1>Danh Sách Thiếu Nhi</h1>
<h4>Số Lượng : <%= @attendances.count %></h4>

<%= render 'students/info_table' %>
<div class="divider"></div>

<%= link_to "In Danh Sách Lớp", cell_path(format: "pdf"), :class =>"button" %>
<%= link_to "In Danh Sách Lớp (Excel)", cell_path(format: "xlsx"), :class =>"button" %>
<%= link_to "In Sơ Yếu Lý Lịch Lớp", cell_path(@cell)+"/students_personal_details.pdf", :class =>"button" %>

app/views/cells/summary.html.erb
<h1><%= @cell.name %></h1>

<p style="margin:10px"></p>

<% @instructions.each do |ins| %>
    <% teacher = ins.teacher %>
    <div>
        <div> 
            <%= "%s: " % [ins.position] %>
            <%= teacher.name %>
        </div>
        <div>
            SDT:
            <%= teacher.phone %>
        </div>
    </div>
<% end %>